"use strict";

require("core-js/modules/es.object.define-property.js");
require("core-js/modules/es.symbol.iterator.js");
require("core-js/modules/es.array.iterator.js");
require("core-js/modules/es.string.iterator.js");
require("core-js/modules/web.dom-collections.iterator.js");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
require("core-js/modules/es.array.concat.js");
require("core-js/modules/es.symbol.to-primitive.js");
require("core-js/modules/es.date.to-primitive.js");
require("core-js/modules/es.symbol.js");
require("core-js/modules/es.symbol.description.js");
require("core-js/modules/es.object.to-string.js");
require("core-js/modules/es.number.constructor.js");
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
// All external libs URLs should be injected through this class.
// CDN libs URLs are accessible throuh CDN object properties
// like Formio.cdn.ace === 'http://cdn.form.io/ace/1.4.12'.
// For latest version use empty string
var CDN = /*#__PURE__*/function () {
  function CDN(baseUrl) {
    _classCallCheck(this, CDN);
    this.baseUrl = baseUrl || 'https://cdn.form.io';
    this.overrides = {};
    this.libs = {
      'ace': '1.4.12',
      'bootstrap': '4.6.2',
      'ckeditor': '19.0.0',
      'flatpickr': '4.6.8',
      'flatpickr-formio': '4.6.13-formio.3',
      'font-awesome': '4.7.0',
      'grid': 'latest',
      'moment-timezone': 'latest',
      'quill': '2.0.0-dev.3',
      'shortcut-buttons-flatpickr': '0.4.0',
      'uswds': '2.4.8',
      'core': ''
    };
    this.updateUrls();
  }
  _createClass(CDN, [{
    key: "getVersion",
    value: function getVersion(lib) {
      return this.libs[lib];
    }

    // Sets a specific library version
  }, {
    key: "setVersion",
    value: function setVersion(lib, version) {
      this.libs[lib] = version;
      this.updateUrls();
    }

    // Sets base CDN url for all libraries
  }, {
    key: "setBaseUrl",
    value: function setBaseUrl(url) {
      this.baseUrl = url;
      this.updateUrls();
    }

    // Allows to override CDN url for a specific library
  }, {
    key: "setOverrideUrl",
    value: function setOverrideUrl(lib, url) {
      this.overrides[lib] = url;
      this.updateUrls();
    }

    // Removes override for a specific library
  }, {
    key: "removeOverride",
    value: function removeOverride(lib) {
      delete this.overrides[lib];
      this.updateUrls();
    }

    // Removes all overrides
  }, {
    key: "removeOverrides",
    value: function removeOverrides() {
      this.overrides = {};
      this.updateUrls();
    }
  }, {
    key: "buildUrl",
    value: function buildUrl(cdnUrl, lib, version) {
      var url;
      if (version === 'latest' || version === '') {
        url = "".concat(cdnUrl, "/").concat(lib);
      } else {
        url = "".concat(cdnUrl, "/").concat(lib, "/").concat(version);
      }
      return url;
    }
  }, {
    key: "updateUrls",
    value: function updateUrls() {
      for (var lib in this.libs) {
        if (lib in this.overrides) {
          this[lib] = this.buildUrl(this.overrides[lib], lib, this.libs[lib]);
        } else {
          this[lib] = this.buildUrl(this.baseUrl, lib, this.libs[lib]);
        }
      }
    }
  }]);
  return CDN;
}();
var _default = CDN;
exports["default"] = _default;