"use strict";

require("core-js/modules/es.object.define-property.js");
require("core-js/modules/es.symbol.iterator.js");
require("core-js/modules/es.array.iterator.js");
require("core-js/modules/es.string.iterator.js");
require("core-js/modules/web.dom-collections.iterator.js");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
require("core-js/modules/es.array.is-array.js");
require("core-js/modules/es.symbol.to-primitive.js");
require("core-js/modules/es.date.to-primitive.js");
require("core-js/modules/es.symbol.js");
require("core-js/modules/es.symbol.description.js");
require("core-js/modules/es.object.to-string.js");
require("core-js/modules/es.number.constructor.js");
var _Component = _interopRequireDefault(require("./_classes/component/Component"));
var _utils = _interopRequireDefault(require("./_classes/component/editForm/utils"));
var _Component2 = _interopRequireDefault(require("./_classes/component/Component.form"));
var _lodash = _interopRequireDefault(require("lodash"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
var Components = /*#__PURE__*/function () {
  function Components() {
    _classCallCheck(this, Components);
  }
  _createClass(Components, null, [{
    key: "EditFormUtils",
    get: function get() {
      return Components._editFormUtils;
    },
    set: function set(value) {
      Components._editFormUtils = value;
    }
  }, {
    key: "baseEditForm",
    get: function get() {
      return Components._baseEditForm;
    },
    set: function set(value) {
      Components._baseEditForm = value;
    }
  }, {
    key: "recalculateComponents",
    value: function recalculateComponents() {
      if (window && window.Formio && window.Formio.AllComponents) {
        Components.setComponents(window.Formio.AllComponents);
      }
    }
  }, {
    key: "components",
    get: function get() {
      if (!Components._components) {
        Components._components = {};
      }
      return Components._components;
    }
  }, {
    key: "setComponents",
    value: function setComponents(comps) {
      // Set the tableView method on BaseComponent.
      if (comps.base) {
        // Implement the tableView method.
        comps.base.tableView = function (value, options) {
          var comp = Components.create(options.component, options.options || {}, options.data || {}, true);
          return comp.getView(value);
        };
      }
      _lodash["default"].assign(Components.components, comps);
    }
  }, {
    key: "addComponent",
    value: function addComponent(name, comp) {
      return Components.setComponent(name, comp);
    }
  }, {
    key: "setComponent",
    value: function setComponent(name, comp) {
      Components.components[name] = comp;
    }
  }, {
    key: "create",
    value: function create(component, options, data) {
      var comp = null;
      if (component.type && Components.components.hasOwnProperty(component.type)) {
        comp = new Components.components[component.type](component, options, data);
      } else if (component.arrayTree) {
        // eslint-disable-next-line new-cap
        comp = new Components.components['datagrid'](component, options, data);
      } else if (component.tree) {
        // eslint-disable-next-line new-cap
        comp = new Components.components['nesteddata'](component, options, data);
      } else if (Array.isArray(component.components)) {
        // eslint-disable-next-line new-cap
        comp = new Components.components['nested'](component, options, data);
      } else if (options && options.server) {
        // eslint-disable-next-line new-cap
        comp = new Components.components['hidden'](component, options, data);
      } else {
        comp = new _Component["default"](component, options, data);
      }
      return comp;
    }
  }]);
  return Components;
}();
exports["default"] = Components;
_defineProperty(Components, "_editFormUtils", _utils["default"]);
_defineProperty(Components, "_baseEditForm", _Component2["default"]);