"use strict";

require("core-js/modules/es.object.define-property.js");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
require("core-js/modules/es.array.find.js");
require("core-js/modules/es.object.to-string.js");
require("core-js/modules/es.array.iterator.js");
require("core-js/modules/web.dom-collections.iterator.js");
require("core-js/modules/es.object.assign.js");
var _utils = _interopRequireDefault(require("./utils"));
var _utils2 = require("../../../../utils/utils");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
/* eslint-disable quotes, max-len */
var _default = [{
  weight: 0,
  input: true,
  label: 'Advanced Logic',
  key: 'logic',
  templates: {
    header: '<div class="row"> \n  <div class="col-sm-6">\n    <strong>{{ value.length }} {{ ctx.t("Advanced Logic Configured") }}</strong>\n  </div>\n</div>',
    row: '<div class="row"> \n  <div class="col-sm-6">\n    <div>{{ row.name }} </div>\n  </div>\n  <div class="col-sm-2"> \n    <div class="btn-group pull-right"> \n      <button class="btn btn-default editRow">{{ ctx.t("Edit") }}</button> \n      <button class="btn btn-danger removeRow">{{ ctx.t("Delete") }}</button> \n    </div> \n  </div> \n</div>'
  },
  type: 'editgrid',
  addAnother: 'Add Logic',
  saveRow: 'Save Logic',
  components: [{
    weight: 0,
    input: true,
    inputType: 'text',
    label: 'Logic Name',
    key: 'name',
    validate: {
      required: true
    },
    type: 'textfield'
  }, {
    weight: 10,
    key: 'triggerPanel',
    input: false,
    title: 'Trigger',
    tableView: false,
    components: [{
      weight: 0,
      input: true,
      tableView: false,
      components: [{
        weight: 0,
        input: true,
        label: 'Type',
        key: 'type',
        tableView: false,
        data: {
          values: [{
            value: 'simple',
            label: 'Simple'
          }, {
            value: 'advanced',
            label: 'Advanced'
          }, {
            value: 'javascript',
            label: 'Javascript'
          }, {
            value: 'json',
            label: 'JSON Logic'
          }, {
            value: 'event',
            label: 'Event'
          }]
        },
        dataSrc: 'values',
        template: '<span>{{ item.label }}</span>',
        type: 'select'
      }, {
        type: 'select',
        input: true,
        label: 'When',
        key: 'whenAndOr',
        tooltip: 'Selecting this will handle the below conditions with AND or OR logic',
        dataSrc: 'values',
        customConditional: function customConditional(_ref) {
          var row = _ref.row;
          return row.type === 'advanced';
        },
        validate: {
          required: true
        },
        data: {
          values: [{
            label: 'When all conditions are met(AND)',
            value: '&&'
          }, {
            label: 'When any conditions are met(OR)',
            value: '||'
          }]
        }
      }, {
        input: true,
        key: 'showAdvanced',
        label: 'Show',
        type: 'hidden',
        tableView: false,
        calculateValue: function calculateValue() {
          return true;
        }
      }, {
        weight: 10,
        label: '',
        key: 'simple',
        type: 'container',
        tableView: false,
        customConditional: function customConditional(_ref2) {
          var row = _ref2.row;
          return row.type === 'simple';
        },
        components: [{
          input: true,
          key: 'show',
          label: 'Show',
          type: 'hidden',
          tableView: false,
          calculateValue: function calculateValue() {
            return true;
          }
        }, {
          type: 'select',
          input: true,
          label: 'When the form component:',
          key: 'when',
          dataSrc: 'custom',
          valueProperty: 'value',
          tableView: false,
          data: {
            custom: function custom(context) {
              return (0, _utils2.getContextComponents)(context);
            }
          }
        }, {
          type: 'textfield',
          input: true,
          label: 'Has the value:',
          key: 'eq',
          tableView: false
        }]
      }, {
        weight: 20,
        input: true,
        label: 'Conditions',
        key: 'advanced',
        tableView: false,
        templates: {
          header: '<div class="row"> \n  <div class="col-sm-6"><strong>{{ value.length }} {{ ctx.t("conditions") }}</strong></div>\n</div>',
          row: '<div class="row"> \n  <div class="col-sm-6">\n    <div>{{ row.name }} </div>\n  </div>\n  <div class="col-sm-2"> \n    <div class="btn-group pull-right"> \n      <button class="btn btn-default editRow">{{ ctx.t("Edit") }}</button> \n      <button class="btn btn-danger removeRow">{{ ctx.t("Delete") }}</button> \n    </div> \n  </div> \n</div>',
          footer: ''
        },
        type: 'editgrid',
        addAnother: 'Add condition',
        saveRow: 'Save condition',
        customConditional: function customConditional(_ref3) {
          var row = _ref3.row;
          return row.type === 'advanced' && row.whenAndOr;
        },
        components: [{
          weight: 0,
          title: 'Condition',
          input: false,
          key: 'conditionPanel',
          type: 'panel',
          components: [{
            type: 'textfield',
            input: true,
            label: 'Name',
            key: 'name',
            tableView: false,
            validate: {
              required: true
            }
          }, {
            type: 'select',
            input: true,
            label: 'Form component',
            key: 'whenAdvanced',
            dataSrc: 'custom',
            valueProperty: 'value',
            tableView: false,
            data: {
              custom: function custom(context) {
                return (0, _utils2.getContextComponents)(context);
              }
            },
            validate: {
              required: true
            }
          }, {
            weight: 0,
            input: true,
            label: 'Condition',
            key: 'operatorAdvanced',
            tableView: false,
            valueProperty: 'value',
            // lazyLoad: true,
            validate: {
              required: true
            },
            data: {
              custom: function custom(value) {
                var _value$instance, _value$instance$optio, _value$instance$optio2;
                // console.log('value-=',value);
                if (value !== null && value !== void 0 && (_value$instance = value.instance) !== null && _value$instance !== void 0 && (_value$instance$optio = _value$instance.options) !== null && _value$instance$optio !== void 0 && (_value$instance$optio2 = _value$instance$optio.editForm) !== null && _value$instance$optio2 !== void 0 && _value$instance$optio2.components) {
                  var _value$instance$optio3, _value$instance$optio4;
                  // console.log('value 0 -',value);
                  var selectedItemDataType = value === null || value === void 0 ? void 0 : (_value$instance$optio3 = value.instance.options.editForm.components) === null || _value$instance$optio3 === void 0 ? void 0 : (_value$instance$optio4 = _value$instance$optio3.find(function (item) {
                    var _value$row;
                    return item.key === (value === null || value === void 0 ? void 0 : (_value$row = value.row) === null || _value$row === void 0 ? void 0 : _value$row.whenAdvanced);
                  })) === null || _value$instance$optio4 === void 0 ? void 0 : _value$instance$optio4.type;
                  // console.log('selectedItemDataType 1-=',selectedItemDataType);
                  if (selectedItemDataType) {
                    return (0, _utils2.getConditionalComparisonOptions)(selectedItemDataType);
                  }
                }
                return (0, _utils2.getConditionalComparisonOptions)();
              }
            },
            dataSrc: 'custom',
            template: '<span>{{ item.label }}</span>',
            type: 'select',
            customConditional: function customConditional(_ref4) {
              var row = _ref4.row;
              return row.whenAdvanced !== '';
            }
          }, {
            type: 'textfield',
            input: true,
            label: 'Value',
            key: 'eqAdvanced',
            tableView: false,
            validate: {
              required: true
            },
            customConditional: function customConditional(value) {
              var _value$instance2, _value$instance2$opti, _value$instance2$opti2;
              var show = false;
              if (value !== null && value !== void 0 && (_value$instance2 = value.instance) !== null && _value$instance2 !== void 0 && (_value$instance2$opti = _value$instance2.options) !== null && _value$instance2$opti !== void 0 && (_value$instance2$opti2 = _value$instance2$opti.editForm) !== null && _value$instance2$opti2 !== void 0 && _value$instance2$opti2.components) {
                var _value$instance$optio5, _value$instance$optio6;
                var selectedItemDataType = (_value$instance$optio5 = value.instance.options.editForm.components) === null || _value$instance$optio5 === void 0 ? void 0 : (_value$instance$optio6 = _value$instance$optio5.find(function (item) {
                  var _value$row2;
                  return item.key === (value === null || value === void 0 ? void 0 : (_value$row2 = value.row) === null || _value$row2 === void 0 ? void 0 : _value$row2.whenAdvanced);
                })) === null || _value$instance$optio6 === void 0 ? void 0 : _value$instance$optio6.type;
                var row = value.row;
                if (selectedItemDataType !== "selectboxes" && selectedItemDataType !== "radio" && selectedItemDataType !== "select" && row.whenAdvanced !== '' && row.operatorAdvanced !== '' && row.operatorAdvanced !== 'isEmpty' && row.operatorAdvanced !== 'isNotEmpty') {
                  show = true;
                }
              }
              return show;
            }
          }, {
            type: 'select',
            input: true,
            label: 'Value',
            key: 'eqAdvancedFromDropdown',
            tableView: false,
            validate: {
              required: true
            },
            valueProperty: 'value',
            data: {
              custom: function custom(value) {
                var _value$instance3, _value$instance3$opti, _value$instance3$opti2;
                // console.log('selectOptions value-=',value);
                if (value !== null && value !== void 0 && (_value$instance3 = value.instance) !== null && _value$instance3 !== void 0 && (_value$instance3$opti = _value$instance3.options) !== null && _value$instance3$opti !== void 0 && (_value$instance3$opti2 = _value$instance3$opti.editForm) !== null && _value$instance3$opti2 !== void 0 && _value$instance3$opti2.components) {
                  var _value$instance$optio7, _selectOptionsData$da;
                  var selectOptionsData = value === null || value === void 0 ? void 0 : (_value$instance$optio7 = value.instance.options.editForm.components) === null || _value$instance$optio7 === void 0 ? void 0 : _value$instance$optio7.find(function (item) {
                    var _value$row3;
                    return item.key === (value === null || value === void 0 ? void 0 : (_value$row3 = value.row) === null || _value$row3 === void 0 ? void 0 : _value$row3.whenAdvanced);
                  });
                  var selectOptions = (selectOptionsData === null || selectOptionsData === void 0 ? void 0 : selectOptionsData.values) || (selectOptionsData === null || selectOptionsData === void 0 ? void 0 : (_selectOptionsData$da = selectOptionsData.data) === null || _selectOptionsData$da === void 0 ? void 0 : _selectOptionsData$da.values);
                  //  console.log('selectOptions 1-=',selectOptions);
                  if (selectOptions) {
                    return selectOptions;
                  }
                }
                return [];
              }
            },
            dataSrc: 'custom',
            customConditional: function customConditional(value) {
              var _value$instance4, _value$instance4$opti, _value$instance4$opti2;
              var show = false;
              if (value !== null && value !== void 0 && (_value$instance4 = value.instance) !== null && _value$instance4 !== void 0 && (_value$instance4$opti = _value$instance4.options) !== null && _value$instance4$opti !== void 0 && (_value$instance4$opti2 = _value$instance4$opti.editForm) !== null && _value$instance4$opti2 !== void 0 && _value$instance4$opti2.components) {
                var _value$instance$optio8, _value$instance$optio9;
                var selectedItemDataType = value === null || value === void 0 ? void 0 : (_value$instance$optio8 = value.instance.options.editForm.components) === null || _value$instance$optio8 === void 0 ? void 0 : (_value$instance$optio9 = _value$instance$optio8.find(function (item) {
                  var _value$row4;
                  return item.key === (value === null || value === void 0 ? void 0 : (_value$row4 = value.row) === null || _value$row4 === void 0 ? void 0 : _value$row4.whenAdvanced);
                })) === null || _value$instance$optio9 === void 0 ? void 0 : _value$instance$optio9.type;
                var row = value.row;
                if ((selectedItemDataType === "selectboxes" || selectedItemDataType === "radio" || selectedItemDataType === "select") && row.whenAdvanced !== '' && row.operatorAdvanced !== '' && row.operatorAdvanced !== 'isEmpty' && row.operatorAdvanced !== 'isNotEmpty') {
                  show = true;
                }
              }
              return show;
            }
          }]
        }]
      }, {
        weight: 10,
        type: 'textarea',
        key: 'javascript',
        rows: 5,
        editor: 'ace',
        as: 'javascript',
        input: true,
        tableView: false,
        placeholder: "result = (data['mykey'] > 1);",
        description: '"row", "data", and "component" variables are available. Return "result".',
        customConditional: function customConditional(_ref5) {
          var row = _ref5.row;
          return row.type === 'javascript';
        }
      }, {
        weight: 10,
        type: 'textarea',
        key: 'json',
        rows: 5,
        editor: 'ace',
        label: 'JSON Logic',
        as: 'json',
        input: true,
        tableView: false,
        placeholder: "{ ... }",
        description: '"row", "data", "component" and "_" variables are available. Return the result to be passed to the action if truthy.',
        customConditional: function customConditional(_ref6) {
          var row = _ref6.row;
          return row.type === 'json';
        }
      }, {
        weight: 10,
        type: 'textfield',
        key: 'event',
        label: 'Event Name',
        placeholder: 'event',
        description: 'The event that will trigger this logic. You can trigger events externally or via a button.',
        tableView: false,
        customConditional: function customConditional(_ref7) {
          var row = _ref7.row;
          return row.type === 'event';
        }
      }],
      key: 'trigger',
      type: 'container'
    }],
    type: 'panel'
  }, {
    weight: 20,
    input: true,
    label: 'Actions',
    key: 'actions',
    tableView: false,
    templates: {
      header: '<div class="row"> \n  <div class="col-sm-6"><strong>{{ value.length }} {{ ctx.t("actions") }}</strong></div>\n</div>',
      row: '<div class="row"> \n  <div class="col-sm-6">\n    <div>{{ row.name }} </div>\n  </div>\n  <div class="col-sm-2"> \n    <div class="btn-group pull-right"> \n      <button class="btn btn-default editRow">{{ ctx.t("Edit") }}</button> \n      <button class="btn btn-danger removeRow">{{ ctx.t("Delete") }}</button> \n    </div> \n  </div> \n</div>',
      footer: ''
    },
    type: 'editgrid',
    addAnother: 'Add Action',
    saveRow: 'Save Action',
    components: [{
      weight: 0,
      title: 'Action',
      input: false,
      key: 'actionPanel',
      type: 'panel',
      components: [{
        weight: 0,
        input: true,
        inputType: 'text',
        label: 'Action Name',
        key: 'name',
        validate: {
          required: true
        },
        type: 'textfield'
      }, {
        weight: 10,
        input: true,
        label: 'Type',
        key: 'type',
        data: {
          values: [{
            value: 'property',
            label: 'Property'
          }, {
            value: 'value',
            label: 'Value'
          }, {
            label: 'Merge Component Schema',
            value: 'mergeComponentSchema'
          }, {
            label: 'Custom Action',
            value: 'customAction'
          }]
        },
        dataSrc: 'values',
        template: '<span>{{ item.label }}</span>',
        type: 'select'
      }, {
        weight: 20,
        type: 'select',
        template: '<span>{{ item.label }}</span>',
        dataSrc: 'json',
        tableView: false,
        data: {
          json: [{
            label: 'Hidden',
            value: 'hidden',
            type: 'boolean'
          }, {
            label: 'Required',
            value: 'validate.required',
            type: 'boolean'
          }, {
            label: 'Disabled',
            value: 'disabled',
            type: 'boolean'
          }, {
            label: 'Label',
            value: 'label',
            type: 'string'
          }, {
            label: 'Title',
            value: 'title',
            type: 'string'
          }, {
            label: 'Prefix',
            value: 'prefix',
            type: 'string'
          }, {
            label: 'Suffix',
            value: 'suffix',
            type: 'string'
          }, {
            label: 'Tooltip',
            value: 'tooltip',
            type: 'string'
          }, {
            label: 'Description',
            value: 'description',
            type: 'string'
          }, {
            label: 'Placeholder',
            value: 'placeholder',
            type: 'string'
          }, {
            label: 'Input Mask',
            value: 'inputMask',
            type: 'string'
          }, {
            label: 'CSS Class',
            value: 'className',
            type: 'string'
          }, {
            label: 'Container Custom Class',
            value: 'customClass',
            type: 'string'
          }]
        },
        key: 'property',
        label: 'Component Property',
        input: true,
        customConditional: function customConditional(_ref8) {
          var row = _ref8.row;
          return row.type === 'property';
        }
      }, {
        weight: 30,
        input: true,
        label: 'Set State',
        key: 'state',
        tableView: false,
        data: {
          values: [{
            label: 'True',
            value: 'true'
          }, {
            label: 'False',
            value: 'false'
          }]
        },
        dataSrc: 'values',
        template: '<span>{{ item.label }}</span>',
        type: 'select',
        customConditional: function customConditional(_ref9) {
          var row = _ref9.row;
          return row.type === 'property' && row.hasOwnProperty('property') && row.property.type === 'boolean';
        }
      }, {
        weight: 30,
        type: 'textfield',
        key: 'text',
        label: 'Text',
        inputType: 'text',
        input: true,
        tableView: false,
        description: 'Can use templating with {{ data.myfield }}. "data", "row", "component" and "result" variables are available.',
        customConditional: function customConditional(_ref10) {
          var row = _ref10.row;
          return row.type === 'property' && row.hasOwnProperty('property') && row.property.type === 'string' && !row.property.component;
        }
      }, {
        weight: 20,
        input: true,
        label: 'Value (Javascript)',
        key: 'value',
        editor: 'ace',
        as: 'javascript',
        rows: 5,
        placeholder: "value = data.myfield;",
        type: 'textarea',
        tableView: false,
        description: '"row", "data", "component", and "result" variables are available. Return the value.',
        customConditional: function customConditional(_ref11) {
          var row = _ref11.row;
          return row.type === 'value';
        }
      }, {
        weight: 20,
        input: true,
        label: 'Schema Defenition',
        key: 'schemaDefinition',
        editor: 'ace',
        as: 'javascript',
        rows: 5,
        placeholder: "schema = { label: 'Updated' };",
        type: 'textarea',
        tableView: false,
        description: '"row", "data", "component", and "result" variables are available. Return the schema.',
        customConditional: function customConditional(_ref12) {
          var row = _ref12.row;
          return row.type === 'mergeComponentSchema';
        }
      }, Object.assign(_utils["default"].logicVariablesTable('<tr><th>input</th><td>The value that was input into this component</td></tr>'), {
        customConditional: function customConditional(_ref13) {
          var row = _ref13.row;
          return row.type === 'customAction';
        }
      }), {
        weight: 20,
        input: true,
        label: 'Custom Action (Javascript)',
        key: 'customAction',
        editor: 'ace',
        rows: 5,
        placeholder: "value = data.myfield;",
        type: 'textarea',
        tableView: false,
        customConditional: function customConditional(_ref14) {
          var row = _ref14.row;
          return row.type === 'customAction';
        }
      }]
    }]
  }]
}];
/* eslint-enable quotes, max-len */
exports["default"] = _default;